﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: true
	#IncludeTitle: false
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private level_Label As Label

	Private usernameEditText As B4XFloatTextField
	Private Save_profileButton As Button
	Private email_EditText As EditText
	Private background_ImageView As ImageView
	Private reg_Label As Label
	
	

	Dim ip As String
	Dim deviceNumber As String
	Dim usernamelenghtcheck As Boolean
	Dim emaillenghtcheck As Boolean
	Dim logOperation As String
	
	Private edit_Button As Button
	Private PhotoImageView As ImageView
	Private btcEditText As EditText
	Private btcLabel As Label
	Dim MySafeFolder As String  = functions.rp.GetSafeDirDefaultExternal("db")
	
	Private Drawer As B4XDrawer
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	Activity.LoadLayout("profile")
'	Drawer.Initialize(Me, "Drawer", Activity, 200dip)

	If Main.usrExist = 1 Then   'se l' utente esiste
		
		ReadDataBase   'leggo il database
			
		usernameEditText.TextField.Enabled = False
		email_EditText.Enabled = False
		If btcEditText.Text = "" Then 
			
			btcEditText.Enabled = False
			Save_profileButton.Visible = False
			
		End If
	Else 
		reg_Label.Text = "Created on: " & DateUtils.TicksToString(DateTime.Now)		
		' aspetto che l' utente inserisca i campi e salvi
		level_Label.Text = "Level: 0"
	End If


	PhotoImageView.Bitmap = LoadBitmap(File.DirAssets,"user.png")
	background_ImageView.Color = Colors.RGB(0,124,245)
	
	email_EditText.TextColor = Colors.white
	level_Label.TextColor = Colors.white
	reg_Label.TextColor = Colors.white
	btcEditText.TextColor = Colors.White
	btcLabel.TextColor = Colors.white
	functions.UDP_Socket.Initialize("UDP",9001,3000)

	
	functions.checkinternet


	deviceNumber = functions.GetDeviceId
	
	PickIPaddress
	

	
End Sub

Sub Activity_Resume
	
If Main.usrExist = 1 Then 
	
		ReadDataBase	
End If
	
	
	
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then
		If functions.UDP_Socket.IsInitialized Then
			functions.UDP_Socket.Close
		End If
	End If
End Sub



Public Sub sendLog

	Dim DoGetLog As HttpJob
	DoGetLog.Initialize("GenLog", Me)
	DoGetLog.download2("http://192.168.1.43/persons/persons.php", Array As String ("action", "doLog", "deviceid",deviceNumber,"operation",logOperation,"username",usernameEditText.Text.Replace(" ",""),"IPaddress",ip))

	Log(ip)

End Sub

Sub JobDone(Job As HttpJob)
	ProgressDialogHide
	Wait For (Job) JobDone(Job As HttpJob)
	If Job.Success Then
		Dim res As String
		res = Job.GetString
		Log("Back from Job:" & Job.JobName )
		Log("Response from server: " & res)
		
		Select Job.JobName
						

			Case "GenLog"
				ToastMessageShow("Log done",True)
			Case "DomysqlUser1"
				ToastMessageShow("Add new user on mysql done",True)
			Case "DomysqlUserUp1"
				ToastMessageShow("Fields updated",True)

		End Select

	Else
		ToastMessageShow("Error: " & Job.ErrorMessage, True)
	End If
	Job.Release
	
End Sub


Sub Save_profileButton_Click
	
	
		'creo il nuovo utente nel database dopo che ha compilato i campi richiesti
	If Main.usrExist = 0 Then
		checkfieldLenght
			If 	 usernamelenghtcheck = True And emaillenghtcheck = True Then
	
	
	create_mysql_user
	
			ToastMessageShow("New User Created", False)
	
			usernameEditText.TextField.Enabled = False
			email_EditText.Enabled = False
	
			If btcEditText.Text <> "" Then
				
				btcEditText.Enabled  = False
				Save_profileButton.Enabled= False
				Save_profileButton.Visible = False
	
			End If
				
		Else
		
			MsgboxAsync("input Error","Error")

		End If	
		
	Else 'se l' utente già esiste
		
		
		If btcEditText.Text <> "" Then
			update_user_field	
			Save_profileButton.Enabled= False
			Save_profileButton.Visible = False
			btcEditText.Enabled  = False
			
			
		End If
	
		'

		
	End If
	
End Sub



Sub checkfieldLenght
	
If usernameEditText.Text  = "" Or usernameEditText.Text.Length >15 Then
	
		MsgboxAsync("Username too long","ERROR")
		usernamelenghtcheck = False
		
	Else
		usernamelenghtcheck = True
		Log(usernameEditText.Text)
	End If
	
	
	If email_EditText.Text = "" Or email_EditText.Text.Length > 30 Or functions.IsEmail(email_EditText.Text) = False Then
	
		MsgboxAsync("Oops, please double check your email address","ERROR")
'		ToastMessageShow("Oops, please double check your email address",True)
		emaillenghtcheck = False
	Else
		
		emaillenghtcheck = True
	Log(email_EditText.Text)
	End If
End Sub



Private Sub ReadDataBase

	Dim InsertNewPerson As HttpJob

	Dim j As HttpJob
	j.Initialize("", Me) 'name is empty as it is no longer needed
	j.Download("http://192.168.1.43/persons/restapi.php?api=tbl-users&my-deviceid="& functions.GetDeviceId)
	Wait For (j) JobDone(j As HttpJob)
	If j.Success Then
	'The result is a json string. We parse it and log the fields.
	Dim parser As JSONParser
	parser.Initialize(j.GetString)
	Dim root As List = parser.NextArray
		For Each colroot As Map In root
			Dim my_level As Int = colroot.Get("my_level")
			Dim my_energy As Int = colroot.Get("my_energy")
			Dim my_username As String = colroot.Get("my_username")
			Dim my_totclick As Int = colroot.Get("my_totclick")
			Dim my_enabled As String = colroot.Get("my_enabled")
			Dim my_totbalance As Int = colroot.Get("my_totbalance")
			Dim my_email As String = colroot.Get("my_email")
			Dim my_last_see As String = colroot.Get("my_last_see")
			Dim my_registration_date As String = colroot.Get("my_registration_date")
			Dim my_deviceid As String = colroot.Get("my_deviceid")
			Dim my_balance As Int = colroot.Get("my_balance")
			Dim my_btcaddress As String = colroot.Get("my_btcaddress")
			Dim my_exp As Int = colroot.Get("my_exp")
			Dim my_iduser As Int = colroot.Get("my_iduser")
		Next

		usernameEditText.text = my_username
		email_EditText.Text = my_email
		reg_Label.text = Colors.white
		level_Label.Text =   "Level: " & my_level
		btcEditText.Text = my_btcaddress
		reg_Label.Text = my_registration_date
		
		If btcEditText.Text = "" Then
			Save_profileButton.Enabled= True
			Save_profileButton.Visible = True
			btcEditText.Enabled  = True
			
			
		End If
			
End If	





	
'	usernameEditText.Text = RemoveRedundantSpace(ResultSet1.GetString("username"))	'read the FirstName column
'	email_EditText.Text = ResultSet1.GetString("email")
'	level_Label.Text = "User level: "& ResultSet1.GetString("level")
'	reg_Label.Text = "Created on: " & ResultSet1.GetString("regTime")
'	Log(email_EditText.Text)
'	Log(email_EditText.Text)
'	Log(ResultSet1.GetString("ipaddress"))
'	ResultSet1.Close
End Sub



Sub RemoveRedundantSpace(TextToClean As String) As String
	Dim jo As JavaObject = Regex.matcher("[ ]{2,}", TextToClean)
	Return jo.RunMethod("replaceAll", Array(" "))
End Sub


Sub PickIPaddress
	
	Dim Packet As UDPPacket
	Dim data(28) As Byte

	data(0) = 0x00
	data(1) = 0x01 ' message type=binding request
	data(2) = 0x00
	data(3) = 0x08 ' message length
	Dim k As Int
	For k = 0 To 15
		data(4+k) = Rnd(0x00,0xff) ' stun id = 16 random byte
	Next
	
	data(20) = 0x00
	data(21) = 0x03 'CHANGE_REQUEST type
	data(22) = 0x00
	data(23) = 0x04 'length
	data(24) = 0x00
	data(25) = 0x00
	data(26) = 0x00
	data(27) = 0x00 'data
	
	'using free stun server, example:
	'stun1.voiceeclipse.net
	'stun.sipgate.net
	'stun.voxalot.com
	'
	'Packet.Initialize(data, "stun1.voiceeclipse.net",3478)    'IP and Port can be changed
	Packet.Initialize(data, "stun.sipgate.net",3478)    'IP and Port can be changed
	functions.UDP_Socket.send(Packet)
	
End Sub


 Sub UDP_PacketArrived (Packet As UDPPacket)
	Dim msg As String
	Private Query As String
	Dim k As Int
	msg = BytesToString(Packet.data, Packet.offset, Packet.Length, "ASCII")
		
	If (Packet.Data(0) = 0x01) And (Packet.Data(1) = 0x01) Then
		k = Packet.Data(21)
		k = Bit.Or(Bit.ShiftLeft(Packet.Data(20),8),k)
		If k = 0x01 Then
			'MAPPED ADDRESS
			ip = Bit.And(0xff,Packet.Data(28))&"." & Bit.And(0xff,Packet.Data(29)) _
			& "." &Bit.And(0xff,Packet.Data(30))&"."&Bit.And(0xff,Packet.Data(31))
			Log("Public IP: " &ip)
		
		End If
	End If
	
		
End Sub


Public Sub create_mysql_user

	Dim DomysqlUser As HttpJob
	DomysqlUser.Initialize("DomysqlUser", Me)
	DomysqlUser.download2("http://192.168.1.43/persons/persons.php", Array As String ("action", "create_mysql_user", "deviceid",deviceNumber,"username",usernameEditText.Text.Replace(" ",""),"email",email_EditText.Text.Replace(" ",""),"btcaddress",btcEditText.Text))
	Wait For (DomysqlUser) JobDone(DomysqlUser As HttpJob)
	If DomysqlUser.Success Then
		
		
		logOperation = "New Profile"
	
		sendLog
			
		ToastMessageShow("New User Created",True)
		
	Else
		ToastMessageShow("Error: " & DomysqlUser.ErrorMessage, True)
		
		
	End If

End Sub

Public Sub update_user_field
	
	Dim DomysqlUserUp As HttpJob
	DomysqlUserUp.Initialize("update_mysql_btcAddressOnly", Me)
	DomysqlUserUp.download2("http://192.168.1.43/persons/persons.php", Array As String ("action", "update_mysql_profile", "deviceid",deviceNumber,"btcaddress",btcEditText.Text))
	Wait For (DomysqlUserUp) JobDone(DomysqlUserUp As HttpJob)
	If DomysqlUserUp.Success Then
		
		ToastMessageShow("User Fields Updated",True)
		
		
		Save_profileButton.Visible = False
		
		
	Else
		ToastMessageShow("Error: " & DomysqlUserUp.ErrorMessage, True)
		
		
	End If
End Sub


Sub usernameEditText_TextChanged (Old As String, New As String)
	
If	Old.EqualsIgnoreCase(New) = True Then
	
	
End If
	
	
	
End Sub

Sub email_EditText_TextChanged (Old As String, New As String)
	
	If	Old.EqualsIgnoreCase(New) = True Then
		
		Return
	
	End If
	
End Sub

Sub btcEditText_TextChanged (Old As String, New As String)
	
	
	If	Old.EqualsIgnoreCase(New) = True Then
	
	
	End If
	
	
	
End Sub


#If Java

public boolean _onCreateOptionsMenu(android.view.Menu menu) {
    if (processBA.subExists("activity_createmenu")) {
        processBA.raiseEvent2(null, true, "activity_createmenu", false, new de.amberhome.objects.appcompat.ACMenuWrapper(menu));
        return true;
    }
    else
        return false;
}
#End If

Sub lblBack_Click
	Activity.Finish
End Sub


