﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.8
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Public SQL1 As SQL
	Dim UDP_Socket As UDPSocket
	Public CurrentIndex = -1 As Int		' index of the current entry
	Dim objWFI As WaitForInternet
	Public RowIDList As List		' list containing the RowIDs of the database
	Dim rp As RuntimePermissions
	Dim MySafeFolder As String  = rp.GetSafeDirDefaultExternal("db")
	Private ServerIP As String
	
End Sub



Sub IsEmail(EmailAddress As String) As Boolean
'	EmailAddress = email_EditText.Text
	Dim MatchEmail As Matcher = Regex.Matcher("^(?i)[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])$", EmailAddress)
	If MatchEmail.Find = True Then
		Log(MatchEmail.Match)
		'Do something
		Return True
	Else
		
		Return False
	End If
End Sub


Sub checkinternet
	objWFI.JavaDebug = True
	objWFI.PingHostOnReceive = True
	objWFI.Initialize("objWFI")
	'objWFI.PingHost = RPLabel.text
	LogColor("[isConnectedToInternet]" & objWFI.isConnectedToInternet() ,Colors.Blue)
	
	
	If objWFI.isConnectedToInternet = False Then
		MsgboxAsync("NO INTERNET CONNECTION","WARNING")
		
'		profile.Activity.Finish
	End If
	
End Sub

Sub GetDeviceId As String
	Dim r As Reflector
	Dim Api As Int
	Api = r.GetStaticField("android.os.Build$VERSION", "SDK_INT")
	If Api < 9 Then
		'Old device
		If File.Exists(File.DirInternal, "__id") Then
			Return File.ReadString(File.DirInternal, "__id")
		Else
			Dim id As Int
			id = Rnd(0x10000000, 0x7FFFFFFF)
			File.WriteString(File.DirInternal, "__id", id)
			Return id
		End If
	Else
		'New device
		Return r.GetStaticField("android.os.Build", "SERIAL")
	End If
End Sub

public Sub CreateDataBase
	Private Query As String

	'create the database with 3 columns
	Query = "CREATE TABLE IF NOT EXISTS profile (iduser	INTEGER PRIMARY KEY AUTOINCREMENT, deviceid TEXT UNIQUE, username TEXT UNIQUE,pphoto TEXT, email	TEXT UNIQUE, level	INTEGER DEFAULT 0, exp INTEGER DEFAULT 0, balance REAL DEFAULT 0.00000000,totbalance REAL DEFAULT 0.00000000, enabled	INTEGER DEFAULT 1, ipaddress TEXT, regTime	DATETIME NOT NULL DEFAULT (strftime('%d-%m-%Y', 'now', 'localtime')), btcaddress TEXT, energy INTEGER)"
	'
	SQL1.ExecNonQuery(Query)
	Log(SQL1.ExecQuerySingleResult("SELECT count(*) FROM profile"))
	
	
	
	
End Sub

