﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	
#End Region

Sub Process_Globals
	Private WakeState As PhoneWakeState
	Private tmr As Timer
	Private mGap As Float
End Sub

Sub Service_Create
	tmr.Initialize("tmr", 1000)
	Service.AutomaticForegroundMode = Service.AUTOMATIC_FOREGROUND_ALWAYS
	WakeState.PartialLock
End Sub

Sub Service_Start (StartingIntent As Intent)
	'Service.StartForeground(1, CreateNotification("App avviata"))

End Sub

Sub Service_Destroy

End Sub

Public Sub StartTimer(Duration As Float)
	If tmr.Enabled Then tmr.Enabled = False
	mGap = 100 / Duration
	Main.gCurrentTime = Duration * 1000
	tmr.Enabled = True
End Sub

Public Sub StopTimer
	tmr.Enabled = False
	Dim notif As Notification = CreateNotification("Timer fermato")
	notif.Notify(1)
End Sub

Private Sub tmr_Tick
	If Main.gCurrentTime = 0 Then
		StopTimer
		Main.gValue = 0
	Else
		Main.gValue = Main.gValue + mGap
		Main.gCurrentTime = Main.gCurrentTime - 1000
		Log(Main.gValue)
		Log(Main.gCurrentTime)
	End If
	If Not(IsPaused(Main)) Then
		CallSubDelayed(Main, "UpdateGUI")
	End If
End Sub

Sub CreateNotification (Body As String) As Notification
	Dim notification As Notification
	notification.Initialize2(notification.IMPORTANCE_HIGH)
	notification.Icon = "icon"
	notification.SetInfo(Application.LabelName, Body, Main)
	Return notification
End Sub
